import * as oa from 'openapi3-ts';
import 'reflect-metadata';
import { MetadataArgsStorage, RoutingControllersOptions } from 'routing-controllers';
import { ActionMetadataArgs } from 'routing-controllers/metadata/args/ActionMetadataArgs';
import { ControllerMetadataArgs } from 'routing-controllers/metadata/args/ControllerMetadataArgs';
import { ParamMetadataArgs } from 'routing-controllers/metadata/args/ParamMetadataArgs';
import { ResponseHandlerMetadataArgs } from 'routing-controllers/metadata/args/ResponseHandleMetadataArgs';
export interface IRoute {
    readonly action: ActionMetadataArgs;
    readonly controller: ControllerMetadataArgs;
    readonly options: RoutingControllersOptions;
    readonly params: ParamMetadataArgs[];
    readonly responseHandlers: ResponseHandlerMetadataArgs[];
}
export declare function routingControllersToSpec(storage: MetadataArgsStorage, routingControllerOptions?: RoutingControllersOptions, additionalProperties?: Partial<oa.OpenAPIObject>): oa.OpenAPIObject;
export declare function parseRoutes(storage: MetadataArgsStorage, options?: RoutingControllersOptions): IRoute[];
export declare function getFullPath(route: IRoute): string;
export declare function getOperation(route: IRoute): oa.OperationObject;
export declare function getOperationId(route: IRoute): string;
export declare function getPathParams(route: IRoute): oa.ParameterObject[];
export declare function getQueryParams(route: IRoute): oa.ParameterObject[];
export declare function getRequestBody(route: IRoute): oa.RequestBodyObject | void;
export declare function getResponses(route: IRoute): oa.ResponsesObject;
export declare function getSummary(route: IRoute): string;
export declare function getTags(route: IRoute): string[];
